<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: MagentoClient.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: MagentoClient.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import _ from 'lodash';

/**
 * Magento Client
 *
 * @class
 * @returns {Promise} Return a promise object
 */
// eslint-disable-next-line import/prefer-default-export
export default class MagentoClient {
  /**
   * @member {AxiosInstance} connection
   */
  connection

  /**
   * Constructor description
   *
   * @param {AxiosInstance} magentoConnection MagentoConnection should be passed
   * @param {string} defaultStore Determines which store to default to when requesting data.
   */
  constructor (magentoConnection, defaultStore = 'all') {
    this.connection = magentoConnection;
    this.defaultStore = defaultStore;
  }

  /**
   * Make a get request to Magento
   *
   * @param {string} path
   * @param {string=} store Optionally Override Store
   * @param {AxiosRequestConfig=} axiosRequestConfig Optionally add Axios configuration for request
   */
  get (path, store, axiosRequestConfig) {
    let currentStore = store;
    if (!_.isString(store)) {
      currentStore = this.defaultStore;
    }

    const requestUrl = MagentoClient.GetMagentoRequestPath(currentStore, path);

    return this.connection.get(requestUrl, axiosRequestConfig);
  }

  /**
   * Get Magento Request URI
   *
   * @param storeCode
   * @param uriPath
   *
   * @throws TypeError
   * @returns {string}
   */
  static GetMagentoRequestPath (storeCode, uriPath) {
    if (!_.isString(storeCode) || !_.isString(uriPath)) {
      throw new TypeError('storeCode and uriPath must both be provided.');
    }

    return `${storeCode}/${_.trimStart(uriPath, '/')}`;
  }

  /**
   * Get full magento request URL
   *
   * @param storeCode
   * @param uriPath
   *
   * @throws TypeError
   * @returns {string}
   */
  getFullMagentoRequestUrl (storeCode, uriPath) {
    if (!_.isString(storeCode) || !_.isString(uriPath)) {
      throw new TypeError('storeCode and uriPath must both be provided.');
    }

    return `${this.connection.defaults.baseURL}` +
      `/${MagentoClient.GetMagentoRequestPath(storeCode, uriPath)}`;
  }

  /**
   * Get full magento request URL
   *
   * @param storeCode
   *
   * @throws TypeError
   * @returns {MagentoClient}
   */
  setDefaultStore (storeCode) {
    if (!_.isString(storeCode)) {
      throw new TypeError('storeCode');
    }

    this.defaultStore = storeCode;

    return this;
  }
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="MagentoClient.html">MagentoClient</a></li><li><a href="MagentoClient_MagentoClient.html">MagentoClient</a></li><li><a href="MagentoConnection.html">MagentoConnection</a></li></ul><h3>Global</h3><ul><li><a href="global.html#connection">connection</a></li><li><a href="global.html#filter">filter</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Feb 07 2020 12:43:27 GMT-0500 (Eastern Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
